/* ===================================================================
 * AlterRecipeSizeForm.java
 * 
 * Created Oct 14, 2004 8:43:36 AM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: AlterRecipeSizeForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.UiData;
import magoffin.matt.ieat.domain.UiSearchResults;
import magoffin.matt.ieat.util.RecipeCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller for altering the size (servings) of a recipe.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class AlterRecipeSizeForm extends AbstractEatForm {
	
	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors) throws Exception {
		WebUtil.getBizContext(request,false);
		
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		
		// add list of systems
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		m.put("uidata",ui);
		
		// add recipe
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Recipe r = recipeBiz.getRecipeById(recipeCommand.getRecipeId());
		ui.getRecipe().add(r);
		
		if ( recipeCommand.getIndex() != null || recipeCommand.getCriteria() != null ) {
			UiSearchResults sr = getDomainObjectFactory().getEmbeddedSearchResultsInstance();
			WebUtil.initSearchResults(sr,recipeCommand.getIndex(),recipeCommand.getCriteria(), getDomainObjectFactory());
			ui.setSearchResults(sr);
		}
		return m;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		
		if ( isCancel(request) ) {
			Map<String, Object> model = new LinkedHashMap<String, Object>();
			WebUtil.saveRecipeCommand(model,recipeCommand);
			return new ModelAndView(getCancelView(),model);
		}

		Recipe altered = recipeBiz.alterRecipeSize(
				recipeCommand.getRecipeId(),recipeCommand.getSize());
		Map<String, Object> model = errors.getModel();
		UiSearchResults sr = getDomainObjectFactory().getSearchResultsInstance();
		sr.getRecipe().add(altered);

		WebUtil.initSearchResults(sr,recipeCommand.getIndex(),recipeCommand.getCriteria(), getDomainObjectFactory());
		
		sr.setMode("altered");
		
		model.put(WebConstants.DEFALUT_MODEL_OBJECT,sr);
		ModelAndView result = new ModelAndView(getSuccessView(),model);
		return result;
	}

	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors) {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveRecipeCommand(model,recipeCommand);
		return new ModelAndView(getCancelView(),model);
	}
	
}
